
/*
 *  Simple program to test the utsname-changer, driver.
 *
 *   Created: Thu Feb  5 14:18:38 EST 2004
 *   Richard B. Johnson
 *   rjohnson@analogic.com
 */

#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "this.h"

static const char devname[]="UNAME";

int main(int args, char *argv[])
{
    int par;
    int fd;
    if(args < 3)
    {
        fprintf(stderr, "Usage:\n%s <Item> <string>\n", argv[0]);
        fprintf(stderr, "Items are SYSNAME, NODENAME, RELEASE, "
                        "VERSION, MACHINE, DOMAIN\n");
        exit(EXIT_FAILURE);
    }
    if((fd = open(devname, O_RDWR)) < 0)
    {
        fprintf(stderr, "Can't open device file, %s\n", devname);
        fprintf(stderr, "Maybe `insmod` the driver?\n");
        exit(EXIT_FAILURE);
    }
    par = 0;
    switch(*argv[1] & 95)
    {
    case 'S':
        par = SET_UNAME_SYSNAME;
        break;
    case 'N':
        par = SET_UNAME_NODENAME;
        break;
    case 'R':
        par = SET_UNAME_RELEASE;
        break;
    case 'V':
        par = SET_UNAME_VERSION;
        break;
    case 'M':
        par = SET_UNAME_MACHINE;
        break;
    case 'D':
        par = SET_UNAME_DOMAIN;
        break;
    default:
        fprintf(stderr, "Unknown Item, %s\n", argv[1]);
        exit(EXIT_FAILURE);
    }
    if(ioctl(fd, par, argv[2]) < 0)
        perror("ioctl");
    (void)close(fd);
    return 0;
}

